/*
  Copyright 2010 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "wxGridCellStarEditor.h"

void wxGridCellStarEditor::BeginEdit (int row, int col, wxGrid *grid) {
    static bool inModification = false;
    wxString value;

    if (inModification) return ;
    
    inModification = true;

    value = grid->GetCellValue(row, col);
    _has_star = (value[value.Length()-1] == '*');

    if (_has_star)
	grid->SetCellValue(row, col, value.RemoveLast());
    
    wxGridCellTextEditor::BeginEdit(row, col, grid);
    
    inModification = false;
}

bool wxGridCellStarEditor::EndEdit (int row, int col, wxGrid *grid/*, const wxString &oldval, wxString *newval*/)
{
    wxString res = GetValue();
    bool ret;

    ret = wxGridCellTextEditor::EndEdit(row, col, grid);

    if (_has_star)
	grid->SetCellValue(row, col, res + wxT("*"));

    return ret;
}

